/* notes from lpj
enke: Here is the *new* offnet protocol you need to implement onn your side:
(the include file follow...)
- open a connection socket 7667
- send PT_DUMPBIN (char) for a binary dump, PT_DUMPASCII for a ascii dump
(for debugging)
- you will recieve a bunch of rt_head_proto structures (cf proto.h),  with
(i hope) what you need
- then you will receive PT_ENDDUMP which mean the dump is done
(in case of a binary dump) (may be broken????....)
- send PT_EOF to close the connection.
*/

typedef  u_char byte;
/*
#define U_INT8 "unsigned char";
#define S_INT8 "char"; 

#define U_INT16 "unsigned short";
#define	S_INT16 "short";
#define U_INT32 "unsigned int";
#define S_INT32 "int";
*/

typedef unsigned char	U_INT8;
typedef char		S_INT8;
typedef unsigned short 	U_INT16;
typedef short		S_INT16;
typedef unsigned int	U_INT32;
typedef int		S_INT32;

/* More generic types */
typedef U_INT8  u_int8;         /* 8 bits unsigned */
typedef S_INT8  s_int8;         /* 8 bits signed */
typedef U_INT16 u_int16;        /* 16 bits unsigned */
typedef S_INT16 s_int16;        /* 16 bits signed */
typedef U_INT32 u_int32;        /* 32 bits unsigned */
typedef S_INT32 s_int32;        /* 32 bits signed */


typedef u_int16 as_t;           /* 16 bits unsigned */
typedef s_int32 pref_t;         /* 32 bits signed */
typedef u_int32 flag_t;         /* 32 bits unsigned */
typedef u_int16 proto_t;        /* 16 bits unsigned */
typedef u_int16 mtu_t;          /* 16 bits unsigned */
typedef u_int32 metric_t;       /* 32 bits unsigned */
typedef u_int32 tag_t;          /* 32 bits unsigned */

#define PT_ENDDUMP      '\0'            /* End of dumping */
#define PT_DUMPASCII    ' '             /* Dump in ascii format */
#define PT_DUMPBIN      '1'             /* Dump in binary */
#define PT_EOF          '\0'            /* Close the connection */


#define	PROTO_INET 	1

typedef union {
    /* Generic address used only for referencing length and family */
    struct {
        byte    sa_len;
        byte    sa_family;
        byte    sa_data[1];
    } a;
    /* Unix domain address */
    struct {
        byte    sun_len;
        byte    sun_family;
        char    sun_path[1];
    } un;
#ifdef  PROTO_INET
    /* IP address.  Note that sin_zero has been removed */
    struct {
        byte    sin_len;
        byte    sin_family;
        u_int16 sin_port;
        struct in_addr sin_addr;
    } in;
#endif  /* PROTO_INET */
#ifdef  SOCKADDR_DL
    struct {
        u_char  sdl_len;        /* Total length of sockaddr */
        u_char  sdl_family;     /* AF_DLI */
        u_short sdl_index;      /* if != 0, system given index for interface */
        u_char  sdl_type;       /* interface type */
        u_char  sdl_nlen;       /* interface name length, no trailing 0 reqd. */
        u_char  sdl_alen;       /* link level address length */
        u_char  sdl_slen;       /* link layer selector length */
        char    sdl_data[1];    /* work area */
    } dl;
#endif  /* SOCKADDR_DL */
#ifdef  PROTO_ISO
    struct {
        u_char siso_len;
        u_char siso_family;
        u_char siso_addr[1];
    } iso;
#endif  /* PROTO_ISO */
    struct {
        u_char sll_len;
        u_char sll_family;
        u_char sll_type;
        u_char sll_addr[1];
    } ll;
    struct {
        byte    ss_len;
        byte    ss_family;
        char    ss_string[1];
    } s;
} sockaddr_un;


/* The protocol unit to transfert the routing table
 */
#define	RTP_MAXAS 255    /* Max AS path lengh. Why not :-) */

typedef struct _rt_head_proto {
        sockaddr_un rtp_dest;           /* Destination */
        sockaddr_un rtp_dest_mask;      /* Mask for the destination */
        byte rtp_entries;               /*Number of routes to this destination*/
        byte rtp_n_announce;            /* number of announcement */
        flag_t rtp_state;               /* State ???? C.f. gated code !!! */
        sockaddr_un rtp_nexthop;        /* The next hop */
        as_t rtp_localas;               /* Our local AS */
        as_t rtp_peeras;                /* peer's AS */
        metric_t rtp_metric;            /* The metric for this route */
        int rtp_aspathlen;              /* Number of AS in the path */
        as_t rtp_aspath[RTP_MAXAS];     /* Table of AS path */
} rt_head_proto;




